%Macro data1(type, per1, per2);
data SASMALM._TypeF;
	format _type_ $3. ;
	format IOTYPE $7. ;
	_type_='LE'; 
	IOType='OUTPUT'; 
	output;
	_type_='LE' ; 
	IOType='INPUT' ; 
	output;
	IOType='OBJ';
	output;
run;
/* Omdanner variabelnavn til uppercase */
data &_VarF;
	set &_varF;
	Variable=upcase(variable);
run;

proc sort data=&_VarF(where=(UPCASE(IOType)='INPUT')) out=SASMALM._VarFi;
	by Variable;
run;
/* Tller inputs */
data _null_;
	set SASMALM._VarFi;
	call symput('_nInput',_n_);
run;

data SASMALM._VarFi;
	do i= 1 to &_nInput;
		Link Read;
		_VarName=compress('X'||i); output;
	end;

	Read: set SASMALM._VarFi; return;
	drop i;
run;

proc sort data=&_VarF(where=(UPCASE(IOType)='OUTPUT')) out=SASMALM._VarFo;
	by Variable;
run;

data _null_;
	set SASMALM._VarFo;
	call symput('_nOutput',_n_);
run;

data SASMALM._VarFo;
	do r= 1 to &_nOutput;
		Link Read;
		_VarName=compress('Y'||r); output;
	end;

	Read: set SASMALM._VarFo; return;
	drop r;
run;
data SASMALM._dataA;
	%if &per2 ne %then %do;
		set &_dataF(where=(Period=&per1. or Period=&per2.));
	%end;
	%else %if &per2= %then %do;
		set &_dataF(where=(Period=&per1.));
	%end;
run;
proc sort data=SASMALM._dataA out=SASMALM._dataA;
	by DMU;
run;

proc summary data=SASMALM._dataA; 
	output out=SASMALM._Dmu1F(keep=DMU);
	by DMU;
run;

data _null_;
	set SASMALM._Dmu1F;
	call symput('_nDmu',_n_);
run;

data SASMALM._DmuF;
	do j= 1 to &_nDmu;
		Link Read;
		_VarName=compress('DMU'||j); output;
	end;

	Read: set SASMALM._Dmu1F; return;
	drop j;
run;

data SASMALM._DataF1;
	merge SASMALM._dataA SASMALM._DmuF ;
	by DMU;
run;

data SASMALM._VarF1;
	set SASMALM._VarFi SASMALM._VarFo;
run;

proc sort data=SASMALM._VarF1;
	by variable;
run;

data SASMALM._ObjF; 
	_VarName='TETA';
	Variable='Objective';
	IOType='OBJ';
	_type_='MIN';
	output;
RUN;

data SASMALM._D&per1.;
	set SASMALM._DataF1(where=(Period=&per1.));
run;
%if &per2 ne %then %do;
	data SASMALM._D&per2.;
		set SASMALM._DataF1(where=(Period=&per2.));
	run;
%end;

data SASMALM._TypeF;
	set SASMALM._TypeF;
	IOTYPE=UPCASE(IOTYPE);
run;

%data3(&per1);

%if &per2 ne %then %do;
	%data3(&per2);
%end;

data SASMALM._Model01;
	set SASMALM._F4&per1.;
	_Kind='T1xt1yt1';
run;
%if &per2 ne %then %do;
	data SASMALM._Model02;
		set SASMALM._F4&per2.;
		_Kind='T2xt2yt2';
	run;
%end;
%mend data1;

%macro data3(per);
%let t=&per;  
	proc transpose data=SASMALM._D&t.(drop=DMU) out=SASMALM._D&t.t(rename=_Name_=Variable);
		id _VarName;
	run;
	data SASMALM._D&t.t;
		set SASMALM._D&t.t;
		Variable=UPCASE(Variable);
	run;
	proc sort data=SASMALM._D&t.t;
		by variable;
	run;
	

	data SASMALM._VarF2;
		merge SASMALM._VarF1(in=IO) SASMALM._D&t.t (in=Dt) ;
			by Variable; if Dt and IO;
	run;
	proc sort data=SASMALM._VarF2;
		by IOType;
	run;
	proc sort data=SASMALM._TypeF;
		by IOType;
	run;
	data SASMALM._F4&t.;
		merge SASMALM._VarF2(in=Dt) SASMALM._TypeF;
			by IOType;
		Period=&t.;
		if Dt;
	run;
	data SASMALM._F4&t.;
		set SASMALM._F4&t. ;
		if UpCase(IOTYPE)='OUTPUT' then do;
			%do j0=1 %to &_nDmu ;
				DMU&j0=-DMU&j0;
			%end;
		end;
	run;

%mend data3;
* Macro for transfering data files to suitable
format for Malmquist index;
%macro data2(Uj0);


data SASMALM._Model0x(keep=_varname &Uj0 rename=(&Uj0=TempUj0));
	set SASMALM._F4&per1.;
run;

data SASMALM._Model0y;
	merge SASMALM._Model0x SASMALM._F4&per2.;
		by _VarName;
run;

data SASMALM._Model03;
	set SASMALM._Model0y;
	_Kind='T2xt1yt1';
run;
data SASMALM._Model0x(keep=_varname &Uj0 rename=(&Uj0=TempUj0));
	set SASMALM._F4&per2.;
run;

data SASMALM._Model0y;
	merge SASMALM._Model0x SASMALM._F4&per1.;
		by _VarName;
run;
data SASMALM._Model04;
	set SASMALM._Model0y;
	_Kind='T1xt2yt2';
run;
%mend data2;


* Macro for preparation dual model;
%macro Duality(_PrimF, _DualF, _Ind);
proc sort data=&_PrimF out=SASMALM.Temp1;
	by _row_;
run;

data SASMALM.Temp1(drop=TEMPUj0);
	set SASMALM.temp1;
run;

proc transpose data =SASMALM.Temp1 out=SASMALM.Temp2; id _row_ ;
run;

proc transpose data=SASMALM.Temp1 out=SASMALM.c(rename=(_name_=_col_ col1=_coef_));
	by _type_ _row_ notsorted ;
	var  FI DMU1-DMU%sysevalf(&_nDmu) _rhs_ ;
run;

data SASMALM.object;
   LENGTH _col_ $ 5;
	_type_='MIN';
	_row_='OBJECT';
	_col_='FI';
	_coef_=1;
	output;
	_type_='MIN';
	_row_='OBJECT';
	_col_='_RHS_';
	_coef_=.;
	output;
run;

data &_DualF;
	set SASMALM.object SASMALM.c ;
run;
%mend Duality;

%macro DEA(DMUj0, M, type);
data SASMALM._ModelP1(rename=(_VarName=_row_) drop=IOTYPE PERIOD variable);
	set SASMALM._Model0&M;
		if &M<3 then TEMPUj0=&DMUj0;
		if UPCASE(IOType)='INPUT'  then do;
			FI=-TEMPUj0;
			_RHS_=0 ;
		end;
		if UPCASE(IOType)='OUTPUT' then do;
			FI=0;
			_RHS_=TEMPUj0 ;
		end;
run;

%IF &type='VRS' %then %do;
	data SASMALM.VRS;
		_row_='VRS';
		%do h=1 %to &_nDmu;
			DMU&h=1;
		%end;
		_type_='EQ';
		FI=0;
		_RHS_=1;
	run;
	data SASMALM._modelp1(drop=TEMPUj0 _Kind);
		set SASMALM._modelp1 SASMALM.VRS;
	run;
%end;
%IF &type='NIRS' %then %do;
	data SASMALM.VRS;
		_row_='NIRS';
		%do h=1 %to &_nDmu;
			DMU&h=1;
		%end;
		_type_='LE';
		FI=0;
		_RHS_=1;
	run;
	data SASMALM._modelp1(drop=TEMPUj0 _Kind);
		set SASMALM._modelp1 SASMALM.VRS;
	run;
%end;
%IF &type='NDRS' %then %do;
	data SASMALM.VRS;
		_row_='NDRS';
		%do h=1 %to &_nDmu;
			DMU&h=1;
		%end;
		_type_='GE';
		FI=0;
		_RHS_=1;
	run;
	data SASMALM._modelp1(drop=TEMPUj0 _Kind);
		set SASMALM._modelp1 SASMALM.VRS;
	run;
%end;

%Duality(SASMALM._ModelP1, SASMALM._ModelW1,'LE');
data SASMALM._ModelR1;
	set SASMALM._Modelw1;
	if _row_='FI' then do;
		_rhs_=-1;
	end;
run;

%if &M=1 %then %do;
title "&DMUj0. i &per1."; %end;
%if &M=2 %then  %do;
title "&DMUj0. i &per2."; %end;
%if &M=3 %then  %do;
title "&DMUj0. i &per1., &per2.-rand"; %end;
%if &M=4 %then  %do;
title "&DMUj0. i &per2., &per1.-rand"; %end;

proc LP data= SASMALM._Modelr1 primalout=SASMALM.RP dualout=SASMALM.RD MAXIT2=100000 sparsedata;
run;
title;

data SASMALM.RP;
length _DMUj0 $8.;
	set SASMALM.RP;
	_DMUj0="&DMUj0";
	_KIND=&M.;
run;

data SASMALM.RD;
	length _DMUj0 $8.;
	set SASMALM.RD;
	_DMUj0="&DMUj0";
	_KIND=&M.;
run;

proc datasets nolist force; 
	append base=SASMALM.MRP data=SASMALM.RP;
run;

proc datasets nolist force;
	append base=SASMALM.MRD  data=SASMALM.RD;
run;
%mend dea;

%macro report(type);
data SASMALM._KindF;
	_kind=1; 
	_tKind='T1xt1yt1'; 
	output;
	%if &per2 ne %then %do;
		_kind=2; 
		_tKind='T2xt2yt2'; 
		output;
		_kind=3; 
		_tKind='T2xt1yt1'; 
		output;
		_kind=4; 
		_tKind='T1xt2yt2'; 
		output;
	%end;
run;

proc sort data=SASMALM.mrp(rename=(_Dmuj0=_VarName));
	by _VarName;
run;

proc sort data=SASMALM._DmuF;
	by _VarName;
run;

data SASMALM.report1(keep=DMU _value_ _kind);
	merge SASMALM._DmuF SASMALM.mrp(where=( _var_='FI'));
	by _VarName;
run;

data SASMALM.report1(drop=_value_);
	set SASMALM.report1;
	eff=_value_;
run;

proc sort data=SASMALM.report1;
	by _Kind;
run;

data SASMALM.report1(drop=_kind);
	merge SASMALM.report1 SASMALM._KindF;
	by _kind;
run;

proc sort data=SASMALM.report1;
	by DMU;
run;

proc transpose data=SASMALM.report1	out=SASMALM.report(drop=_name_);
	by DMU;
	id _tkind;
run;

data SASMALM.report2;
	set SASMALM.report;
	label T1xt1yt1="Efficiens &per1.";
	%if &per2 ne %then %do;
		label T2xt2yt2="Efficiens &per2.";
		label T2xt1yt1="Efficiens &per1. med &per2.-rand";
		label T1xt2yt2="Efficiens &per2. med &per1.-rand";
		M1=T1xt2yt2/T1xt1yt1;
		label M1="Malmquist-index (Laspeyre M1)";
		M2= T2xt2yt2/T2xt1yt1;
		label M2="Malmquist-index (Pasche M2)";
		M12= sqrt(M1*M2);
		label M12="Malmquist-index (Fischer M12)";
		M3=(T2xt2yt2/T1xt1yt1);
		label M3="Heraf Catching-up effekt";
		M4= sqrt((T1xt2yt2*T1xt1yt1)/(T2xt1yt1*T2xt2yt2));
		label M4="Heraf Teknologi effekt";
	%end;
run;

data _null_;
	call symput('SKALA2',&type);
run;
/* Printer output som rtf via ODS */
%if &per2= %then %do;
	options papersize=A4 nodate orientation=PORTRAIT;
	data _null_;
		call symput('FILEOUT',&_libname||"\Output fra DEA-makro (&SKALA2., &per1.).rtf");
	run;
	title "Resultater: DEA, &SKALA2., &per1.";
	ods rtf file="&FILEOUT.";
	proc print data=SASMALM.report2 noobs;
	run;
	ods rtf close;
%end;
%else %do;
	options papersize=A4 nodate orientation=LANDSCAPE;
	data _null_;
		call symput('FILEOUT',&_libname||"\Output fra DEA-makro (&SKALA2., &per1.-&per2.).rtf");
	run;
	title "Resultater: DEA, &SKALA2., &per1.-&per2.";
	ods rtf file="&FILEOUT.";
	proc print data=SASMALM.report2 noobs;
	run;
	ods rtf close;
%end;
title;
%mend report;

%macro sasmalm(type, per1, per2);
libname SASMALM &_libname;
	
	%data1(&type, &per1, &per2);
	data _null_;
	set SASMALM._Dmu1F;
	call symput('_nDmu',_n_);
	run;
	proc datasets nolist library=SASMALM ;
		delete MRP MRD;
	run;

	%do j_Note=1 %to &_nDmu %by 1;
		%let Uj0=DMU&j_Note;
		%if &per2 ne %then %do;
			%data2(&Uj0);
			%do M=1 %to 4;
				%DEA(&Uj0, &M, &type);
			%end;
		%end;
		%else %do;
		  %DEA(&Uj0, 1, &type);
		%end;
	%end;
	%report(&type);
	/* Rydder op i midlertidige datasets */
	proc datasets nolist library=SASMALM;
		delete c object report1 temp1 temp2 _dataa _dataf1 _dmu1f _dmuf _kindf _model01 
			   _model02 _model03 _model04 _model0x _model0y _modelp1 _modelr1 _modelw1 
			   _objf _typef _varf1 _varf2 _varfi _varfo rd rp _d&per1 _d&per2 _d&per1.t
			   _d&per2.t _f4&per1 _f4&per2 report vrs mrd mrp;
	run; quit;
%mend sasmalm;

/***************************************************************************************/
/*                                      Indtast optioner                               */
/*                                      ================                               */
/* Directory-navn.......                                                               */ 
   %let _libname='C:\Documents and Settings\Erik Bennike\Dokumenter\Studie\Kandidatdelen\Anvendt OR\H3\Data';
/*                                                                                     */
/* SAS Data fil.........                                                               */ 
   %let _DataF=SASMALM.DATA_OPG3;
/*                                                                                     */
/* SAS Var.-navne fil...                                                               */ 
   %let _VarF=SASMALM.VARS_OPG3;
/*                                                                                     */
/*                                           SYNTAKS                                   */
/*                                           =======                                   */
/*  DEA..........:  %sasmalm(SKALA,per1);                                             */
/*                                                                                     */
/*                   Hvor:                                                             */
/*                         SKALA....: Angives som 'CRS','VRS','NIRS' el. 'NDRS'       */
/*                         PER1.....: Perioden, der skal beregnes for                 */
/*                                                                                     */
/*  Malmquist....:  %sasmalm(SKALA,per1,per2);                                        */
/*                                                                                     */
/*                   Hvor:                                                             */
/*                         SKALA....: Angives som 'CRS','VRS','NIRS' el. 'NDRS'       */
/*                                     Bemrk, at der kan opst infeasible problems    */
/*                                     ved andre antagelser end 'CRS'.                 */
/*                         PER1.....: Frste periode                                  */
/*                         PER2.....: Anden periode                                   */
/*                                                                                     */
/***************************************************************************************/